#include "nds_asm.h"
#include "ARMZ80/z80mac.h"
#include "armsdtmac.h"
#include "equates.h"
//	INCLUDE memory.h
//	INCLUDE gfx.h
//	INCLUDE cart.h
//	INCLUDE z80.h
//	INCLUDE sound.h

	.arm
	.align 4
	.section .text

	.global IO_reset
	.global IO_R
	.global IO_W
	.global Z80_IN
	.global Z80_OUT
	.global Z80_IN_C
	.global Z80_OUT_C
	.global joycfg
	.global spriteinit
	.global refreshEMUjoypads
	.global Bin2BCD


	


scaleparms:	;@NH     FH     NV     FV
	.long 0x0000,0x0100,0xff01,0x0150,0xfeb6,OAM_BUFFER1+6,OAM+774
;@----------------------------------------------------------------------------
IO_reset:
;@----------------------------------------------------------------------------
	adr r6,scaleparms			;@ set sprite scaling params
	ldmia r6,{r0-r6}

	mov r7,#2
scaleloop:
	strh r1,[r5],#8				;@ buffer1, buffer2
	strh r0,[r5],#8
	strh r0,[r5],#8
	strh r3,[r5],#232
		strh r2,[r5],#8
		strh r0,[r5],#8
		strh r0,[r5],#8
		strh r3,[r5],#232
			strh r1,[r5],#8
			strh r0,[r5],#8
			strh r0,[r5],#8
			strh r4,[r5],#232
	subs r7,r7,#1
	bne scaleloop

	strh r2,[r6],#8				;@ 7000200
	strh r0,[r6],#8
	strh r0,[r6],#8
	strh r4,[r6]

	bx lr
;@----------------------------------------------------------------------------
Bin2BCD:		;@ called from ui.c
;@----------------------------------------------------------------------------
	stmfd sp!,{r4}

	mov r1,#0
	adr r3,BCD_table			;@ BCD
	ldr r12,=0x11111110			;@ carry count mask value

Bin2BCD_loop:
	ldr r2,[r3],#4				;@ BCD (read BCD table)
	movs r0,r0,lsr#1			;@ test bit

	bcc Bin2BCD_loop_check
Bin2BCD_calc:
	add r4,r2,r1				;@ r4 = r2 + r1
	eor r2,r1,r2				;@ r2 = r1 XOR r2
	eor r2,r4,r2				;@ r2 = r4 XOR r2
	bic r2,r12,r2				;@ r2 = 0x11111110 AND NOT r2
	orr r2,r2,r2,lsr#1			;@ r2 = r2 OR (r2 LSR 1)
	sub r1,r4,r2,lsr#2			;@ r1 = r4 -  (r2 LSR 2)

Bin2BCD_loop_check:
	bne Bin2BCD_loop
	mov r0,r1

	ldmfd sp!,{r4}
	bx lr

BCD_table:
	.long 0x06666667
	.long 0x06666668
	.long 0x0666666a
	.long 0x0666666e
	.long 0x0666667c
	.long 0x06666698
	.long 0x066666ca
	.long 0x0666678e
	.long 0x066668bc
	.long 0x06666b78
	.long 0x0666768a
	.long 0x066686ae
	.long 0x0666a6fc
	.long 0x0666e7f8
	.long 0x0667c9ea
	.long 0x06698dce
	.long 0x066cbb9c
	.long 0x067976d8
	.long 0x068c87aa
	.long 0x06b8a8ee
	.long 0x076aebdc
	.long 0x086fd7b8
	.long 0x0a7fa96a
	.long 0x0e9eec6e
	.long 0x1cddd87c
	.long 0x39bbaa98
	.long 0x6d76eeca

;@----------------------------------------------------------------------------
refreshEMUjoypads:			;@call every frame
;@----------------------------------------------------------------------------
	mov r11,r11
		ldr r4,=frametotal
		ldr r4,[r4]
		movs r0,r4,lsr#2		;@ C=frame&2 (autofire alternates every other frame)
	ldr r4,=EMUinput
	ldr r4,[r4]
	mov r0,r4,lsr#4
		ldr r2,joycfg
		andcs r4,r4,r2
		tstcs r4,r4,lsr#10		;@ L?
		andcs r4,r4,r2,lsr#16
	and r0,r0,#0x0f
	adr r1,rlud2lrud
	ldrb r0,[r1,r0]


	ands r1,r4,#3				;@ A/B buttons to Knife/Special
	cmpne r1,#3
	eorne r1,r1,#3
	tst r2,#0x400				;@ Swap A/B?
	andne r1,r4,#3
	orr r0,r0,r1,lsl#4
	mov r1,#0
	mov r3,#0
	tst r4,#0x4					;@ Select
	orrne r3,r3,#0x01			;@ Coin
	tst r4,#0x8					;@ Start
	orrne r3,r3,#0x08			;@ Start
	tst r2,#0x20000000			;@ Player2?
	movne r1,r0
	movne r0,#0
	movne r3,r3,lsl#1

	strb r0,joy0state
	strb r1,joy1state
	strb r3,joy2state
	bx lr

joycfg: .long 0x00ff01ff			;@ byte0=auto mask, byte1=(saves R), byte2=R auto mask
						;@ bit 31=single/multi, 30,29=1P/2P, 27=(multi) link active, 24=reset signal received
nrplayers:	.long 0		;@ Number of players in multilink.
joySerial:	.byte 0
joy0state:	.byte 0
joy1state:	.byte 0
joy2state:	.byte 0
rlud2lrud:	.byte 0x00,0x02,0x01,0x03, 0x04,0x06,0x05,0x07, 0x08,0x0a,0x09,0x0b, 0x0c,0x0e,0x0d,0x0f

;@----------------------------------------------------------------------------
Input0_R:		;@ Player1
;@----------------------------------------------------------------------------
;@	mov r11,r11					;@ No$GBA breakpoint
	ldrb r0,joy0state
	eor r0,r0,#0xFF
	bx lr
;@----------------------------------------------------------------------------
Input1_R:		;@ Player2
;@----------------------------------------------------------------------------
;@	mov r11,r11					;@ No$GBA breakpoint
	ldrb r0,joy1state
	eor r0,r0,#0xFF
	bx lr
;@----------------------------------------------------------------------------
Input2_R:		;@ Coins, Start & Service
;@----------------------------------------------------------------------------
	mov r11,r11					;@ No$GBA breakpoint
	ldrb r0,joy2state
	eor r0,r0,#0xFF
	bx lr
;@----------------------------------------------------------------------------
Input3_R:
;@----------------------------------------------------------------------------
	ldr r0,=g_dipswitch0
	ldrb r0,[r0]
	eor r0,r0,#0xFF
	bx lr
;@----------------------------------------------------------------------------
Input4_R:
;@----------------------------------------------------------------------------
	ldr r0,=g_dipswitch1
	ldrb r0,[r0]
	eor r0,r0,#0xFF
	bx lr
;@----------------------------------------------------------------------------
Input5_R:
;@----------------------------------------------------------------------------
	ldr r0,=g_dipswitch2
	ldrb r0,[r0]
	eor r0,r0,#0xFF
	bx lr

;@----------------------------------------------------------------------------
IO_R:			;@ I/O read, 0xE000-0xFFFFF
;@----------------------------------------------------------------------------
;@	mov r11,r11					;@ No$GBA breakpoint
	sub r1,addy,#0xE000
	cmp r1,#0x40
	bmi Scrl_R
	cmp addy,#0xF200
	beq Input4_R
	cmp addy,#0xF400
	beq Input5_R
	bic r1,addy,#3
	cmp r1,#0xF600
	and r1,addy,#3
	ldreq pc,[pc,r1,lsl#2]
;@---------------------------
	b empty_IO_R
;@io_read_tbl
	.long Input3_R				;@ 0xF600
	.long Input1_R				;@ 0xF601
	.long Input0_R				;@ 0xF602
	.long Input2_R				;@ 0xF603
;@----------------------------------------------------------------------------
Scrl_R:
;@----------------------------------------------------------------------------
	ldr r2,=SCRL_RAM
	ldrb r0,[r2,r1]
	mov pc,lr



;@----------------------------------------------------------------------------
Z80_IN_C:
;@----------------------------------------------------------------------------
	mov addy,z80bc,lsr#16
;@----------------------------------------------------------------------------
Z80_IN:
;@----------------------------------------------------------------------------
	mov r11,r11					;@ No$GBA breakpoint
	bx lr
;@----------------------------------------------------------------------------
Z80_OUT_C:
;@----------------------------------------------------------------------------
	mov addy,z80bc,lsr#16
;@----------------------------------------------------------------------------
Z80_OUT:
;@----------------------------------------------------------------------------
	mov r11,r11					;@ No$GBA breakpoint
	bx lr
;@----------------------------------------------------------------------------
IO_W:		;@I/O write, 0xE000-0xFFFFF
;@----------------------------------------------------------------------------
;@	mov r11,r11					;@ No$GBA breakpoint
	cmp addy,#0xF400
	beq SN_0_W
	sub r1,addy,#0xE000
	cmp r1,#0x40
	bmi Scrl_W
	cmp r1,#0x43
	beq SpriteBank_W
	cmp r1,#0x44
	beq Flip_W
	cmp addy,#0xF000
	beq Coin_W

	bx lr
;@----------------------------------------------------------------------------
Scrl_W:
;@----------------------------------------------------------------------------
	ldr r2,=SCRL_RAM
	strb r0,[r2,r1]
	bx lr

;@----------------------------------------------------------------------------
Flip_W:
;@----------------------------------------------------------------------------
	ldr r1,=goemon
	ldr r1,[r1]
	cmp r1,#0
	biceq r0,r0,#2				;@ 2 used by Goemon
	bicne r0,r0,#4				;@ 4 used by Green Beret
	ldr r1,=irqControl
	strb r0,[r1]
	bx lr
;@----------------------------------------------------------------------------
SpriteBank_W:
;@----------------------------------------------------------------------------
	ldr r1,=sprBank
	strb r0,[r1]
	bx lr
;@----------------------------------------------------------------------------
WatchDog_W:
;@----------------------------------------------------------------------------
	bx lr
;@----------------------------------------------------------------------------
Coin_W:
;@----------------------------------------------------------------------------
	tst r0,#1
	ldrne r2,=coincounter0
	ldrne r1,[r2]
	addne r1,r1,#1
	strne r1,[r2]
	tst r0,#2
	ldrne r2,=coincounter1
	ldrne r1,[r2]
	addne r1,r1,#1
	strne r1,[r2]

	and r0,r0,#0xE0
	ldr r1,=romstart
	ldr r1,[r1]
	sub r1,r1,#0x3800
	add r1,r1,r0,lsl#6
	str_ r1,z80_memmap_tbl+28
	bx lr
;@----------------------------------------------------------------------------
